/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel  
 * 
 *  Copyright (C) 2000-2002 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  Copyright (C) 2005 by Freelines CO.,Ltd
 *
 *  Copyright (C) 2010,2013 by Meika Sugimoto
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 */

#include "kernel_impl.h"
#include "target_serial.h"

#define TNUM_SIOP	(3)

/*
 *  ꥢݡȤν֥å
 */
typedef struct sio_port_initialization_block {
	uint8_t		tx_intno;	/* ߤγֹ */
	uint8_t		rx_intno;	/* ߤγֹ */
} SIOPINIB;

/*
 *  ꥢݡȤ֥å
 */
struct sio_port_control_block {
	const SIOPINIB	*p_siopinib;	/* ֥å */
	intptr_t	exinf;				/* ĥ */
	bool_t		openflag;			/* ץѤߥե饰 */
	int_t		port_id;			/* ݡֹ(0) */
	bool_t		received;			/* ̵ͭե饰 */
};

SIOPCB siopcb_table[TNUM_SIOP];

/*
 *  SIO ID ֥åؤѴޥ
 */

#define INDEX_SIO(sioid)	((uint_t)((sioid) - 1))
#define get_siopcb(sioid)	(&(siopcb_table[INDEX_SIO(sioid)]))

/*
 *  ꥢݡȤΥϡɥ¸
 */

#define SERIAL_CLKDIV			(0x01)
#define SERIAL_COMPAREVALUE		(0x82)

/* ꥢϢ쥸 */
#define UAnCTL0(x)  (UA0CTL0 + ((x) * 0x10))
#define UAnCTL1(x)  (UA0CTL1 + ((x) * 0x10))
#define UAnCTL2(x)  (UA0CTL2 + ((x) * 0x10))
#define UAnOPT0(x)  (UA0OPT0 + ((x) * 0x10))
#define UAnSTR(x)   (UA0STR  + ((x) * 0x10))
#define UAnRX(x)    (UA0RX   + ((x) * 0x10))
#define UAnTX(x)    (UA0TX   + ((x) * 0x10))
#define UAnRIC(x)	(UA0RIC  + ((x) * 0x10))
#define UAnTIC(x)	(UA0TIC  + ((x) * 0x10))

/*
 *	ꥢ֥å
 */
const SIOPINIB siopinib_table[TNUM_SIOP] =
{
	{ 50u , 49u } , 	/* UART0 */
	{ 52u , 51u } , 	/* UART1 */
	{ 54u , 53u }	 	/* UART2 */
};


/*
 *  sio_initialize -- ꥢݡȥɥ饤Фν
 */
void
sio_initialize(intptr_t exinf)
{
	uint_t	i;
	
	/*
	 *  ꥢI/Oݡȴ֥åν
	 */
	for (i = 0; i < TNUM_SIOP; i++)
	{
		siopcb_table[i].p_siopinib = &(siopinib_table[i]);
		siopcb_table[i].openflag = false;
		siopcb_table[i].received = false;
	}
}

/*
 *  sio_opn_por -- ݡȤΥץ
 */
SIOPCB *
sio_opn_por(ID siopid, intptr_t exinf)
{
	SIOPCB	*siopcb = get_siopcb(siopid);
	
	if(siopcb->openflag == false)
	{
		siopcb->exinf = exinf;
		siopcb->openflag = true;
		siopcb->port_id = siopid - 1;
		
		/* UARTͭˤ */
		sil_wrb_mem((void *)UAnCTL0(siopcb->port_id), 0x80);	/* UART enable */
		
		/* ܡ졼ȯν */
		sil_wrb_mem((void *)UAnCTL1(siopcb->port_id), SERIAL_CLKDIV);
		sil_wrb_mem((void *)UAnCTL2(siopcb->port_id), SERIAL_COMPAREVALUE);
		
		/* ⡼ */
		sil_wrb_mem((void *)UAnCTL0(siopcb->port_id), 
			sil_reb_mem((void *)UAnCTL0(siopcb->port_id)) | 0x12);
		
		/*  */
		sil_wrb_mem((void *)UAnCTL0(siopcb->port_id), 
			sil_reb_mem((void *)UAnCTL0(siopcb->port_id)) | 0x60);
		
		/* ͭ */
		(void)ena_int(siopcb->p_siopinib->tx_intno);
		(void)ena_int(siopcb->p_siopinib->rx_intno);
	}
	
	return siopcb;
}

/*
 *  sio_snd_chr -- ʸ
 */
bool_t
sio_snd_chr(SIOPCB *siopcb, char chr)
{
	bool_t	result = false;
	
	/* ǽå */
	if((sil_reb_mem((void *)UAnSTR(siopcb->port_id)) & 0x80) == 0)
	{
		sil_wrb_mem((void *)UAnTX(siopcb->port_id), chr);
		result = true;
	}
	
	return result;
}

/*
 *  sio_rcv_chr -- ʸ
 */
int_t sio_rcv_chr(SIOPCB *siopcb)
{
	int_t chr = -1;
	
	if(siopcb->received == true)
	{
		chr = (int_t)sil_reb_mem((void *)UAnRX(siopcb->port_id));
		siopcb->port_id = false;
	}
	
	return chr;
}

/*
 *  sio_ena_cbr -- ꥢ I/O ΥХåε
 */
void
sio_ena_cbr(SIOPCB *siopcb, uint_t cbrtn)
{
	switch (cbrtn) {
		case SIO_RDY_SND:
			ena_int(siopcb->p_siopinib->tx_intno);
			break;
		case SIO_RDY_RCV:
			ena_int(siopcb->p_siopinib->rx_intno);
			break;
		default:
			assert(1);
			break;
	}
}

/*
 *  sio_dis_cbr -- ꥢ I/O ΥХåζػ
 */
void
sio_dis_cbr(SIOPCB *siopcb, uint_t cbrtn)
{
	switch (cbrtn) {
		case SIO_RDY_SND:
			dis_int(siopcb->p_siopinib->tx_intno);
			break;
		case SIO_RDY_RCV:
			dis_int(siopcb->p_siopinib->rx_intno);
			break;
		default:
			assert(1);
			break;
	}
}

/*
 *  sio_cls_por -- ݡȤΥ
 */
void
sio_cls_por(SIOPCB *siopcb)
{
	/* UART */
	sil_wrb_mem((void *)UAnCTL0(siopcb->port_id) , 
		(sil_reb_mem((void *)UAnCTL0(siopcb->port_id)) & ~0x80));
	
	/* ߤζػ */
	dis_int(siopcb->p_siopinib->tx_intno);
	dis_int(siopcb->p_siopinib->rx_intno);
	
	/* ե饰 */
	siopcb->openflag = false;
	siopcb->received = false;
}

void
sio_tx_isr(intptr_t exinf)
{
	SIOPCB	*siopcb = get_siopcb(exinf);
	
	/* ХåƤӽФ */
	sio_irdy_snd(siopcb->exinf);
}

void
sio_rx_isr(intptr_t exinf)
{
	SIOPCB	*siopcb = get_siopcb(exinf);
	
	/* Ѥߥե饰򥻥å */
	siopcb->received = true;
	/* ХåƤӽФ */
	sio_irdy_rcv(siopcb->exinf);
}

